Pixlr.Grab = {
	startx: 150,
	starty: 150,
	endx: 550,
	endy: 300,
	movex: 100,
	movey: 100,
	boxWidth:0,
	boxHeight:0,
	dragging: false,
	moving: false,
	resizing: false,
	mousedown: false,
	selectedTab: -1,
	data: '',
	
	SetupGrab: function()
	{
		Pixlr.Grab.CleanUp();
		
		var cssRef = content.document.createElement('link');
		cssRef.id = 'pixlr-style';
		cssRef.rel = 'stylesheet';
		cssRef.href = 'chrome://pixlr/content/grab.css';
		cssRef.type = 'text/css';
		content.document.getElementsByTagName('head')[0].appendChild(cssRef);
	},
	GrabEntire: function()
	{
		Pixlr.Grab.SetupGrab();
		
		var h = 0, w = 0;
		if(window.content.document.compatMode == "CSS1Compat") {
			h = window.content.document.documentElement.scrollHeight;
			w = window.content.document.documentElement.scrollWidth;
		}
		else {
			h = window.content.document.body.scrollHeight;
			w = window.content.document.body.scrollWidth;
		}
		Pixlr.Grab.Grab(window.content,0,0,w,h);
	},
	GrabVisible: function()
	{
		Pixlr.Grab.SetupGrab();
	
		var x = window.content.scrollX;
		var y = window.content.scrollY; 
		var h = 0, w = 0;
		if(window.content.document.compatMode == "CSS1Compat") {
			h = window.content.document.documentElement.clientHeight;
			w = window.content.document.documentElement.clientWidth;
		}
		else {
			h = window.content.document.body.clientHeight;
			w = window.content.document.body.clientWidth;
		}
		Pixlr.Grab.Grab(window.content,x,y,w,h);
	},
	GrabPortion: function()
	{
		Pixlr.Grab.SetupGrab();
		Pixlr.Grab.DisplayArea();
	},
	GrabSelected: function()
	{
		Pixlr.Grab.RemoveArea(window.top.getBrowser().selectedBrowser.contentDocument);
		
		var x = window.content.scrollX;
		var y = window.content.scrollY; 
		
		Pixlr.Grab.Grab(window.content, Pixlr.Grab.startx+x, Pixlr.Grab.starty+y, Pixlr.Grab.endx-Pixlr.Grab.startx, Pixlr.Grab.endy-Pixlr.Grab.starty);
	},
	Grab: function(win, x, y, w, h)
	{
		const MAX_DIM = 8192;
		var canvasW = w;
		var canvasH = h;
		if( w>MAX_DIM || h>MAX_DIM) {
			if(w > h) {
				canvasW = MAX_DIM;
				canvasH = canvasW*h/w;
			}
			else {
				canvasH = MAX_DIM;
				canvasW = canvasH*w/h;
			}
		}
		var canvas = document.createElementNS('http://www.w3.org/1999/xhtml','canvas');
		canvas.style.width = canvasW+"px";
		canvas.style.height = canvasH+"px";
		canvas.width = canvasW;
		canvas.height = canvasH;
		var ctx = canvas.getContext("2d");
		ctx.clearRect(0, 0, canvasW, canvasH);
		ctx.save();
		ctx.scale(canvasW/w, canvasH/h);
		ctx.drawWindow(win, x, y, w, h, "rgb(255,255,255)");
		ctx.restore();
		
		Pixlr.Grab.data = canvas.toDataURL("image/png", "");
		
		switch(Pixlr.prefs.getIntPref("afterCapture"))
		{
			case 0: Pixlr.Grab.ShowSelector(); break;
			case 1: Pixlr.Grab.EditClick(); break;
			case 2: Pixlr.Grab.ShareClick(); break;
			case 3: Pixlr.Grab.SaveClick(); break;
			case 4: Pixlr.Grab.CopyClick(); break;
		}
	},
	EditClick: function()
	{
		Pixlr.Grab.LoaderStep();
		Pixlr.SendRequest.SaveDataURL(Pixlr.Grab.data, "image/png", "pixlr");
	},
	ShareClick: function()
	{
		Pixlr.Grab.LoaderStep();
		Pixlr.SendRequest.SaveDataURL(Pixlr.Grab.data, "image/png", "immio");
	},
	SaveClick: function()
	{
		Pixlr.Grab.CleanUp();
		Pixlr.FileSave.SaveAs(Pixlr.Grab.data);
	},
	CopyClick: function()
	{
		Pixlr.Grab.LoaderStep();
		Pixlr.Clipboard.ImgageData(Pixlr.Grab.data);
	},
	ShowSelector: function()
	{
		var doc = window.content.document
		var bod = doc.getElementsByTagName('body')[0];
		
		Pixlr.Grab.AddDivElement(doc, bod, 'pixlr-overlay-shadow');
		var selector = Pixlr.Grab.AddDivElement(doc, bod, 'pixlr-overlay-selector'); 
		
		var edit = Pixlr.Grab.AddDivElement(doc, selector, 'pixlr-edit');
		edit.addEventListener("mousedown", Pixlr.Grab.EditClick, false);
		edit.innerHTML = "EDIT<div>In Pixlr.com</div>";
		
		var share = Pixlr.Grab.AddDivElement(doc, selector, 'pixlr-share');
		share.addEventListener("mousedown", Pixlr.Grab.ShareClick, false);
		share.innerHTML = "SHARE<div>To Imm.io</div>";
		
		var save = Pixlr.Grab.AddDivElement(doc, selector, 'pixlr-save');
		save.addEventListener("mousedown", Pixlr.Grab.SaveClick, false);
		save.innerHTML = "SAVE<div>To Desktop</div>";
		
		var copy = Pixlr.Grab.AddDivElement(doc, selector, 'pixlr-copy');
		copy.addEventListener("mousedown", Pixlr.Grab.CopyClick, false);
		copy.innerHTML = "COPY<div>To Clipboard</div>";
		
		var close = Pixlr.Grab.AddDivElement(doc, selector, 'pixlr-close');
		close.addEventListener("mousedown", Pixlr.Grab.CleanUp, false);
	},
	LoaderStep: function()
	{
		var doc = window.content.document;
		var bod = doc.getElementsByTagName('body')[0];
		
		Pixlr.Grab.RemoveElement(doc, "pixlr-overlay-shadow");
		Pixlr.Grab.RemoveElement(doc, "pixlr-overlay-selector");
		
		Pixlr.Grab.AddDivElement(doc, bod, 'pixlr-overlay-shadow');
		Pixlr.Grab.AddDivElement(doc, bod, 'pixlr-overlay-loader'); 
	},
	CreateArea: function(doc)
	{
		var areaProtector = Pixlr.Grab.AddDivElement(doc, doc.body, 'pxa-area-protector');

		Pixlr.Grab.AddDivElement(doc, areaProtector, 'pxa-shadow-top');
		Pixlr.Grab.AddDivElement(doc, areaProtector, 'pxa-shadow-bottom');
		Pixlr.Grab.AddDivElement(doc, areaProtector, 'pxa-shadow-left');
		Pixlr.Grab.AddDivElement(doc, areaProtector, 'pxa-shadow-right');

		var areaElement = Pixlr.Grab.AddDivElement(doc, areaProtector, 'pxa-area');
		
		Pixlr.Grab.AddDivElement(doc, areaElement, 'pxa-container');
		Pixlr.Grab.AddDivElement(doc, areaElement, 'pxa-size');

		var cancel = Pixlr.Grab.AddDivElement(doc, areaElement, 'pxa-cancel');
		cancel.addEventListener("mousedown", function (){Pixlr.Grab.RemoveArea(window.top.getBrowser().selectedBrowser.contentDocument)}, true);
		cancel.innerHTML = "Cancel";
		
		var crop = Pixlr.Grab.AddDivElement(doc, areaElement, 'pxa-crop');
		crop.addEventListener("mousedown", Pixlr.Grab.GrabSelected, true);
		crop.innerHTML = "Crop";

		Pixlr.Grab.AddDivElement(doc, areaElement, 'pxa-north-west');
		Pixlr.Grab.AddDivElement(doc, areaElement, 'pxa-north-east');
		Pixlr.Grab.AddDivElement(doc, areaElement, 'pxa-south-east');
		Pixlr.Grab.AddDivElement(doc, areaElement, 'pxa-south-west');
	},
	DisplayArea: function()
	{
		var actualTab = getBrowser().mTabBox.selectedIndex;

		if(Pixlr.Grab.selectedTab==-1 || (Pixlr.Grab.selectedTab!=-1 && Pixlr.Grab.selectedTab != actualTab))
		{
			if(Pixlr.Grab.selectedTab != -1)
			{
				var oldtab = gBrowser.getBrowserAtIndex(Pixlr.Grab.selectedTab);
				if(oldtab) Pixlr.Grab.RemoveArea(oldtab.contentDocument);
			}
			var doc = window.top.getBrowser().selectedBrowser.contentDocument;

			Pixlr.Grab.CreateArea(doc);

			doc.addEventListener("mousedown", Pixlr.Grab.MouseDown, false);
			doc.addEventListener("dblclick", Pixlr.Grab.GrabSelected, false);
			doc.addEventListener("mousemove", Pixlr.Grab.MouseMove, false);
			doc.addEventListener("mouseup", Pixlr.Grab.MouseUp, false);

			Pixlr.Grab.selectedTab = actualTab;

			if(window.content.document.compatMode == "CSS1Compat") {
				Pixlr.Grab.boxHeight = window.content.document.documentElement.clientHeight;
				Pixlr.Grab.boxWidth = window.content.document.documentElement.clientWidth;
			}
			else {
				Pixlr.Grab.boxHeight = window.content.document.body.clientHeight;
				Pixlr.Grab.boxWidth = window.content.document.body.clientWidth;
			}
			
			var areaElement = doc.getElementById("pxa-area");
			areaElement.style.left = Pixlr.Grab.startx + "px";
			areaElement.style.top = Pixlr.Grab.starty + "px";
			areaElement.style.width = (Pixlr.Grab.endx - Pixlr.Grab.startx) + "px";
			areaElement.style.height = (Pixlr.Grab.endy - Pixlr.Grab.starty) + "px";

			Pixlr.Grab.UpdateShadow(doc, areaElement);
			Pixlr.Grab.UpdateSize(doc);
		}
		selecting_area = 1;
	},
	MouseDown: function(event)
	{
		if(event.button != 2)
		{
			var element = event.target;

			if(element)
			{
				var elementName = element.tagName;
				var ownerDocument = element.ownerDocument;
				
				if(elementName && elementName == "HTML")
				{
					Pixlr.Grab.RemoveArea(window.top.getBrowser().selectedBrowser.contentDocument);
				}
				else if(elementName && ownerDocument)
				{
					Pixlr.Grab.mousedown = true;
				
					var areaElement = ownerDocument.getElementById("pxa-area");
					var xPosition = event.pageX - window.content.scrollX;
					var yPosition = event.pageY - window.content.scrollY;
					
					if(areaElement)
					{
						if(element == ownerDocument.getElementById("pxa-container"))
						{
							Pixlr.Grab.moving = true;
							Pixlr.Grab.movex = xPosition - areaElement.offsetLeft;
							Pixlr.Grab.movey = yPosition - areaElement.offsetTop;
						} 
						else if(element == ownerDocument.getElementById("pxa-north-east"))
						{
							Pixlr.Grab.resizing = true;
							Pixlr.Grab.startx = areaElement.offsetLeft;
							Pixlr.Grab.starty = areaElement.offsetTop + areaElement.clientHeight;
						} 
						else if(element == ownerDocument.getElementById("pxa-north-west"))
						{
							Pixlr.Grab.resizing = true;
							Pixlr.Grab.startx = areaElement.offsetLeft + areaElement.clientWidth;
							Pixlr.Grab.starty = areaElement.offsetTop + areaElement.clientHeight;
						} 
						else if(element == ownerDocument.getElementById("pxa-south-east"))
						{
							Pixlr.Grab.resizing = true;
							Pixlr.Grab.startx = areaElement.offsetLeft;
							Pixlr.Grab.starty = areaElement.offsetTop;
						} 
						else if(element == ownerDocument.getElementById("pxa-south-west"))
						{
							Pixlr.Grab.resizing = true;
							Pixlr.Grab.startx = areaElement.offsetLeft + areaElement.clientWidth;
							Pixlr.Grab.starty = areaElement.offsetTop;
						}
						else
						{
							Pixlr.Grab.dragging = true;
							Pixlr.Grab.endx = 0;
							Pixlr.Grab.endy = 0;
							Pixlr.Grab.startx = xPosition;
							Pixlr.Grab.starty = yPosition;
						}
					}
				}
			}
			event.stopPropagation();
			event.preventDefault();
		}
	},
	MouseMove: function(event)
	{
		var element = event.target;

		if(element && Pixlr.Grab.mousedown)
		{
			var ownerDocument = element.ownerDocument;

			if(ownerDocument)
			{
				var areaElement = ownerDocument.getElementById("pxa-area");

				if(areaElement)
				{
					var xPosition = event.pageX - window.content.scrollX;
					var yPosition = event.pageY - window.content.scrollY;

					if(Pixlr.Grab.dragging || Pixlr.Grab.resizing)
					{
						var width = 0;
						var height = 0;
						
						Pixlr.Grab.endx = xPosition;
						Pixlr.Grab.endy = yPosition;

						if(Pixlr.Grab.startx > Pixlr.Grab.endx)
						{
							width = Pixlr.Grab.startx - Pixlr.Grab.endx;
							areaElement.style.left = xPosition + "px";
						} 
						else
						{
							width = Pixlr.Grab.endx - Pixlr.Grab.startx;
							areaElement.style.left = Pixlr.Grab.startx + "px";
						}

						if(Pixlr.Grab.starty > Pixlr.Grab.endy)
						{
							height = Pixlr.Grab.starty - Pixlr.Grab.endy;
							areaElement.style.top = Pixlr.Grab.endy + "px";
						} 
						else
						{
							height = Pixlr.Grab.endy - Pixlr.Grab.starty;
							areaElement.style.top = Pixlr.Grab.starty + "px";
						}
						areaElement.style.height = height + "px";
						areaElement.style.width  = width + "px";
					} 
					else if(Pixlr.Grab.moving)
					{
						var newXPosition = xPosition - Pixlr.Grab.movex;
						var newYPosition = yPosition - Pixlr.Grab.movey;

						if (newXPosition < 0) {
							newXPosition = 0;
						}
						else if(newXPosition + areaElement.clientWidth > Pixlr.Grab.boxWidth) {
							newXPosition = Pixlr.Grab.boxWidth - areaElement.clientWidth;
						}
						
						if (newYPosition < 0) {
							newYPosition = 0;
						}
						else if(newYPosition + areaElement.clientHeight > Pixlr.Grab.boxHeight) {
							newYPosition = Pixlr.Grab.boxHeight - areaElement.clientHeight;
						}
						
						areaElement.style.left = newXPosition + "px";
						areaElement.style.top  = newYPosition + "px";
						Pixlr.Grab.endx   = newXPosition + areaElement.clientWidth;
						Pixlr.Grab.startx = newXPosition;
						Pixlr.Grab.endy   = newYPosition + areaElement.clientHeight;
						Pixlr.Grab.starty = newYPosition;
					}
					Pixlr.Grab.UpdateShadow(ownerDocument, areaElement);
					Pixlr.Grab.UpdateSize(ownerDocument);
				}
			}
		}
	},
	UpdateShadow: function(doc, areaElement)
	{
		var width, height;
		
		var shadowTop = doc.getElementById("pxa-shadow-top");
		shadowTop.style.height = parseInt(areaElement.style.top) + "px";
		shadowTop.style.width = (parseInt(areaElement.style.left) +  parseInt(areaElement.style.width) + 1) +"px";
		
		var shadowLeft = doc.getElementById("pxa-shadow-left");
		shadowLeft.style.height = (Pixlr.Grab.boxHeight - parseInt(areaElement.style.top)) + "px";
		shadowLeft.style.width = parseInt(areaElement.style.left) + "px";
		
		height = (parseInt(areaElement.style.top)+parseInt(areaElement.style.height) + 1);
		width = (Pixlr.Grab.boxWidth) - 1 - (parseInt(areaElement.style.left) + parseInt(areaElement.style.width));
		
		if(height < 0) height = 0;
		if(width < 0) width = 0;
		
		var shadowRight = doc.getElementById("pxa-shadow-right");
		shadowRight.style.height = height + "px";
		shadowRight.style.width =  width + "px";
		
		height = (Pixlr.Grab.boxHeight - 1 - (parseInt(areaElement.style.top)+parseInt(areaElement.style.height)));
		width = (Pixlr.Grab.boxWidth) - parseInt(areaElement.style.left);
		
		if(height < 0) height = 0;
		if(width < 0) width = 0;
		
		var shadowBottom = doc.getElementById("pxa-shadow-bottom");
		shadowBottom.style.height = height + "px";
		shadowBottom.style.width = width + "px";
	},
	MouseUp: function(event)
	{
		Pixlr.Grab.mousedown = false;
	
		if(event.button != 2)
		{
			Pixlr.Grab.resizing = false;
			Pixlr.Grab.dragging = false;
			Pixlr.Grab.moving = false;
			Pixlr.Grab.movex = 0;
			Pixlr.Grab.movey = 0;
			
			if(Pixlr.Grab.endx < Pixlr.Grab.startx) {
				var nx = Pixlr.Grab.endx;
				Pixlr.Grab.endx = Pixlr.Grab.startx;
				Pixlr.Grab.startx = nx;
			}
			if(Pixlr.Grab.endy < Pixlr.Grab.starty) {
				var ny = Pixlr.Grab.endy;
				Pixlr.Grab.endy = Pixlr.Grab.starty;
				Pixlr.Grab.starty = ny;
			}
		}
	},
	RemoveArea: function(doc)
	{
		Pixlr.Grab.RemoveElement(doc, "pxa-area-protector");
		Pixlr.Grab.RemoveElement(doc, "pxa-area");

		Pixlr.Grab.selectedTab = -1;

		try { doc.removeEventListener("mousedown", Pixlr.Grab.MouseDown, false); } catch(exception) { }
		try { doc.removeEventListener("mousemove", Pixlr.Grab.MouseMove, false); } catch(exception) { }
		try { doc.removeEventListener("mouseup", Pixlr.Grab.MouseUp, false); } catch(exception) { }
		try { doc.removeEventListener("dblclick", Pixlr.Grab.GrabSelected, false); } catch(exception) { }
		
		Pixlr.Grab.selecting_area = 0;
	},
	CleanUp: function()
	{
		var doc = window.top.getBrowser().selectedBrowser.contentDocument;
		
		Pixlr.Grab.RemoveArea(doc);
		
		Pixlr.Grab.RemoveElement(doc, "pixlr-style");
		Pixlr.Grab.RemoveElement(doc, "pixlr-overlay-shadow");
		Pixlr.Grab.RemoveElement(doc, "pixlr-overlay-loader");
		Pixlr.Grab.RemoveElement(doc, "pixlr-overlay-selector");
	},
	UpdateSize: function(doc)
	{
		var width, height;
		var areaSizeElement = doc.getElementById("pxa-size");

		if(Pixlr.Grab.endx > Pixlr.Grab.startx){
			width = Pixlr.Grab.endx - Pixlr.Grab.startx;
		} else {
			width = Pixlr.Grab.startx - Pixlr.Grab.endx;
		}
		
		if(Pixlr.Grab.endy > Pixlr.Grab.starty){
			height = Pixlr.Grab.endy - Pixlr.Grab.starty;
		} else {
			height = Pixlr.Grab.starty - Pixlr.Grab.endy;
		}
		areaSizeElement.innerHTML = width +" x "+ height;
	},
	AddDivElement: function(doc, parent, id)
	{
		var el = doc.createElement('div');
		el.id = id; parent.appendChild(el);
		return el;
	},
	RemoveElement: function(doc, id)
	{
		if(doc.getElementById(id)) {
			doc.getElementById(id).parentNode.removeChild(doc.getElementById(id));
		}
	}
};
window.addEventListener("load", Pixlr.Grab.OnLoad, false);