Pixlr = {
	prefs:null,
	OnLoad: function()
	{
		Pixlr.prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
		Pixlr.prefs = Pixlr.prefs.getBranch("extensions.pixlr.");
		
		var status = document.getElementById("pixlr-statusbar");
		if(status) status.hidden = !Pixlr.prefs.getBoolPref("iconInStatusbar");
	},
	HideShow: function(ref, what, hideorshow)
	{
		switch(what)
		{
			case "toolbar": obj = ref.document.getElementById("pixlr-toolbar"); break;
			case "menu": obj = ref.document.getElementById("pixlr-menu"); break;
		}
		if(obj) obj.hidden = hideorshow;
	},
	Open: function(what)
	{
		switch(what)
		{
			case "editor":
			case "express": 
				Pixlr.OpenIn("http://pixlr.com/"+ what);
				break;
			case "immio":
				Pixlr.OpenIn("http://imm.io/");
				break;
		}
	},
	OpenIn: function(url)
	{
		switch(Pixlr.prefs.getIntPref("openEditorIn"))
		{
			case 0:
				gBrowser.selectedTab = gBrowser.addTab(url);
				break;
			case 1:
				var features = "fullscreen=yes,resizable=yes,menubar=no,location=no,status=no,toolbar=no";
				window.open(url, 'pixlr', features);
				break;
			case 2:
				window.content.location.href = url;
				break;
		}	
	},
	Settings: function()
	{
		var features = "chrome,titlebar,toolbar,centerscreen,modal";
		window.openDialog("chrome://pixlr/content/options.xul", "Preferences", features);
	},
	GetFileName : function(justDomain)
	{
		var name = window.content.document.domain;
		
		if(!justDomain)
		{
			var date = new Date();
			var year = date.getFullYear();
			var month = date.getMonth()+1;
			var day = date.getDate();
			var mins = date.getMinutes();
			var sec = date.getSeconds();
			
			if(month.length == 1) {
				month = "0" + month;
			}
			if(day.length == 1) {
				day = "0" + day;
			}
			if(mins.length == 1) {
				mins = "0" + mins;
			}
			
			name += " "+ year +"-"+ month +"-"+ day +" "+ date.getHours() +":"+ mins +":"+ sec;
		}
		return name +".png";
	}
};
window.addEventListener("load", Pixlr.OnLoad, false);
