Pixlr.SendRequest = {
	SaveDataURL: function(url, mimeType, target)
	{
		const MULTI						= "@mozilla.org/io/multiplex-input-stream;1";
		const STRINGIS					= "@mozilla.org/io/string-input-stream;1";
		const IOSVC						= "@mozilla.org/network/io-service;1"
		const nsIMultiplexInputStream	= Components.interfaces.nsIMultiplexInputStream;
		const nsIStringInputStream		= Components.interfaces.nsIStringInputStream;
		const nsIIOService				= Components.interfaces.nsIIOService
		const BOUNDARY					= "345823569845694578678";

		var header = new String();
		header += "--" + BOUNDARY + "\r\n";
		header += "content-disposition: form-data; name=\"image\"; filename=\""+Pixlr.GetFileName(true)+"\"\r\n";
		header += "content-type: "+mimeType+"\r\n";
		header += "\r\n";
		var header_stream = Components.classes[STRINGIS].createInstance(nsIStringInputStream);
		header_stream.setData(header, header.length);

		// create a data url from the canvas and then create a stream
		var io = Components.classes[IOSVC].getService(nsIIOService);
		var channel = io.newChannelFromURI(io.newURI(url, "UTF8", null) );
		var data_stream = channel.open();

		// Ending MIME boundary
		var end_stream = Components.classes[STRINGIS].createInstance(nsIStringInputStream);
		var bs = new String("\r\n--" + BOUNDARY + "--\r\n");
		end_stream.setData(bs, bs.length);

		// Stick 'em all together
		var mux_stream = Components.classes[MULTI].createInstance(nsIMultiplexInputStream);
		mux_stream.appendStream(header_stream);
		mux_stream.appendStream(data_stream);
		mux_stream.appendStream(end_stream);

		var req = new XMLHttpRequest();
		
		if(target == 'pixlr') {
			req.open('POST', "http://pixlr.com/store/", true);
			req.onreadystatechange = function(){ Pixlr.SendRequest.PixlrRequestState(req); };
		}
		else{
			req.open('POST', "http://imm.io/?callback=true", true);
			req.onreadystatechange = function(){ Pixlr.SendRequest.ImmioRequestState(req); };
		}
		req.setRequestHeader("content-type", "multipart/form-data; boundary=" + BOUNDARY);
		req.setRequestHeader("content-length", mux_stream.available());
		req.send(mux_stream);
	},
	PixlrRequestState: function(req)
	{
		if(req.readyState == 4)
		{
			Pixlr.Grab.CleanUp();
			
			if(req.status == 200)
			{
				var result = req.responseText;
				var editor = (Pixlr.prefs.getIntPref("editorToOpen") == 0) ? "editor":"express";
				var url = "http://pixlr.com/"+ editor +"/?grab=ber&image=http://pixlr.com/_temp/"+ result +"&title="+ Pixlr.GetFileName(true) +"&credentials=true";
				Pixlr.OpenIn(url);
			}
			else 
			{
				alert('We are sorry but we where unable to send the request\nstatus=' + req.status);
			}
		}
	},
	ImmioRequestState: function(req)
	{
		if(req.readyState == 4)
		{
			Pixlr.Grab.CleanUp();
			
			if(req.status == 200)
			{
				Pixlr.OpenIn(req.responseText);
			}
			else 
			{
				alert('We are sorry but we where unable to send the request\nstatus=' + req.status);
			}
		}
	}
}